package com.zt.plat.module.base.service.tmpltp;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.zt.plat.framework.tenant.core.context.CompanyContextHolder;
import com.zt.plat.module.base.controller.admin.templtp.vo.TemplateInstanceItemPageReqVO;
import com.zt.plat.module.base.controller.admin.templtp.vo.TemplateInstanceItemRespVO;
import com.zt.plat.module.base.controller.admin.templtp.vo.TemplateInstanceItemSaveReqVO;
import com.zt.plat.module.base.dal.dataobject.tmpltp.TemplateInstanceItemDO;
import com.zt.plat.module.base.dal.mysql.tmpltp.TemplateInstanceItemMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import java.util.*;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;
import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.module.tmpltp.enums.ErrorCodeConstants.*;

/**
 * 实例条款值 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
@Slf4j
public class TemplateInstanceItemServiceImpl implements TemplateInstanceItemService {

    @Resource
    private TemplateInstanceItemMapper templateInstanceItemMapper;

    @Override
    public TemplateInstanceItemRespVO createTemplateInstanceItem(TemplateInstanceItemSaveReqVO createReqVO) {
        //判断当前实例条款关系在数据库中存在
        validateTemplateInstanceItemExistsByInscId(createReqVO.getInscId(), createReqVO.getItmId());
        // 插入
        TemplateInstanceItemDO templateInstanceItem = BeanUtils.toBean(createReqVO, TemplateInstanceItemDO.class);
        templateInstanceItemMapper.insert(templateInstanceItem);
        log.info("创建成功实例与条款关系成功，记录为【{}】", templateInstanceItem);
        // 返回
        return BeanUtils.toBean(templateInstanceItem, TemplateInstanceItemRespVO.class);
    }

    @Override
    public void updateTemplateInstanceItem(TemplateInstanceItemSaveReqVO updateReqVO) {
        // 校验存在
        validateTemplateInstanceItemExists(updateReqVO.getId());
        // 更新
        TemplateInstanceItemDO updateObj = BeanUtils.toBean(updateReqVO, TemplateInstanceItemDO.class);
        templateInstanceItemMapper.updateById(updateObj);
        log.info("更新成功实例与条款关系成功，记录为【{}】", updateObj);
    }

    @Override
    public void deleteTemplateInstanceItem(String id) {
        // 校验存在
        validateTemplateInstanceItemExists(id);
        // 删除
        templateInstanceItemMapper.deleteById(id);
        log.info("删除成功实例与条款关系成功，记录为【{}】", id);
    }

    @Override
        public void deleteTemplateInstanceItemListByIds(List<String> ids) {
        // 校验存在
        validateTemplateInstanceItemExists(ids);
        // 删除
        templateInstanceItemMapper.deleteByIds(ids);
        log.info("删除成功实例与条款关系成功，记录为【{}】", ids);
        }

    private void validateTemplateInstanceItemExists(List<String> ids) {
        List<TemplateInstanceItemDO> list = templateInstanceItemMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(TEMPLATE_INSTANCE_ITEM_NOT_EXISTS);
        }
    }

    private void validateTemplateInstanceItemExists(String id) {
        if (templateInstanceItemMapper.selectById(id) == null) {
            throw exception(TEMPLATE_INSTANCE_ITEM_NOT_EXISTS);
        }
    }

    @Override
    public TemplateInstanceItemDO getTemplateInstanceItem(String id) {
        return templateInstanceItemMapper.selectById(id);
    }

    @Override
    public PageResult<TemplateInstanceItemDO> getTemplateInstanceItemPage(TemplateInstanceItemPageReqVO pageReqVO) {
        return templateInstanceItemMapper.selectPage(pageReqVO);
    }

    @Override
    public List<TemplateInstanceItemRespVO> createBatchTemplateInstanceItem(List<TemplateInstanceItemSaveReqVO> createReqVOS) {
        if (CollUtil.isEmpty(createReqVOS)) {
            throw exception(PARAMS_IS_NULL_OR_ERR);
        }
        List<TemplateInstanceItemDO> templateInstanceItemDOList = BeanUtils.toBean(createReqVOS, TemplateInstanceItemDO.class);
        templateInstanceItemMapper.insertBatch(templateInstanceItemDOList);
        return BeanUtils.toBean(templateInstanceItemDOList, TemplateInstanceItemRespVO.class);
    }

    private void  validateTemplateInstanceItemExistsByInscId(String inscId, String itmId){
        if (templateInstanceItemMapper.selectCount(new LambdaQueryWrapper<TemplateInstanceItemDO>().eq(TemplateInstanceItemDO::getInscId, inscId).eq(TemplateInstanceItemDO::getItmId, itmId).eq(TemplateInstanceItemDO::getCompanyId, CompanyContextHolder.getCompanyId())) > 0){
            throw exception(TMPL_ITM_EXISTS);
        }
    }

}
